*+
*+
*+    Source Module => H:\DLOADS\FTP\TEMP\WRITEMVT.PRG
*+
*+    Copyright (C) 1997, Phil Barnett. All Rights Reserved Worldwide.
*+
*+    Functions: Function WriteMvtSui()
*+               Function cReadMvtSui()
*+
*+    Reformatted by Click! 1.08 on Jun-18-1997 at 11:35 pm
*+
*+

*+
*+
*+    Function WriteMvtSui()
*+
*+
*+
function WriteMvtSui( cFic, cCle, cZone, cTexte, bBlock )

/*
   PM le 27/10/95
   Write in MvtSui !

   PARAMETER:
      cFic     -> Master file
      cCle     -> Index key
      cZone    -> Field name
      cTexte   -> Text 
      [bBlock] -> Code-Block to execute if exist
*/

local nPosi
local aMvtSui := MvtSui->( aSaveRestFile() )  // Save the indexord and the recno

cFic  := upper( alltrim( cFic ) )
cCle  := padr( cCle, len( MvtSui->cle ) )
cZone := upper( cZone )

MvtSui->( dbsetorder( 1 ) )
MvtSui->( dbseek( MEMVAR->orgpub + cFic + cCle + cZone ) )
// First we delete the old text (I did a procedure to write ON the old
// text to gain space, but I don

do while
   MvtSui->codorg + MvtSui->fichier + MvtSui->cle + MvtSui->zone == memvar->orgpub + cFic + cCle + cZone
   IF MvtSui->( RecLock( 9 ) )
      MvtSui->( dbdelete() )
   endif
   MvtSui->( dbskip() )
enddo

// Write the new text
do while !empty( cTexte )
   nPosi := at( chr( 10 ), cTexte )
   nPosi := if( nPosi = 0, len( cTexte ), nPosi - 2 )
   IF MvtSui->( AddRec( 9 ) )
      MvtSui->codorg  := memvar->orgpub
      MvtSui->fichier := cFic
      MvtSui->cle     := cCle
      MvtSui->zone    := cZone
      MvtSui->prelig  := left( cTexte, nPosi )
      MvtSui->retour  := substr( cTexte, nPosi + 1, 2 )
      IF bBlock # NIL
         eval( bBlock )
      endif
      MvtSui->( dbunlock() )
   endif
   cTexte := stuff( cTexte, 1, nPosi + 2, "" )
enddo

MvtSui->( aSaveRestFile( aMvtSui ) )

return NIL

*+
*+
*+    Function cReadMvtSui()
*+
*+
*+
function cReadMvtSui( cFic, cCle, cZone, nLigne )

/*
   PM le 27/10/95
   Read in MvtSui !

   PARAMETERS:
      cFic     -> Master file
      cCle     -> Index key
      cZone    -> Field name
      [nLigne] -> Nomber of line to read (i.e. if only the first line is
needed)
*/

local cRetour := ''
local cLig    := ''
local aMvtSui := MvtSui->( aSaveRestFile() )
local nLin    := 0

cFic          := upper( alltrim( cFic ) )
cCle          := padr( cCle, len( MvtSui->cle ) )
cZone         := upper( cZone )

MvtSui->( dbsetorder( 1 ) )

IF MvtSui->( dbseek( MEMVAR->orgpub + cFic + cCle + cZone ) )
   do while MvtSui->codorg + MvtSui->fichier + MvtSui->cle + MvtSui->zone == ;
              memvar->orgpub + cFic + cCle + cZone
      cLig    := trim( MvtSui->prelig ) + if( MvtSui->retour = c_RETOUR_MOU, ' ', '' )
      cRetour += cLig + if( empty( MvtSui->retour ), c_RETOUR, MvtSui->retour )
      nLin ++
      IF nLigne # NIL .and. nLin = nLigne
         exit
      endif
      MvtSui->( dbskip() )
   enddo
endif

MvtSui->( aSaveRestFile( aMvtSui ) )

return cRetour

*+ EOF: WRITEMVT.PRG
